/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.chain.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import fr.obeo.acceleo.chain.util.ChainAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support
 * Viewers. The adapters generated by this factory convert EMF adapter
 * notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets. Note that most of the
 * adapters are shared among multiple instances. <!-- begin-user-doc --> <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class ChainItemProviderAdapterFactory extends ChainAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this
	 * adapter factory. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement
	 * {@link org.eclipse.emf.edit.provider.IChangeNotifier}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by
	 * {@link #isFactoryForType isFactoryForType}. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected Collection supportedTypes = new ArrayList();

	/**
	 * This constructs an instance. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public ChainItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Chain} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ChainItemProvider chainItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Chain}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createChainAdapter() {
		if (chainItemProvider == null) {
			chainItemProvider = new ChainItemProvider(this);
		}

		return chainItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Repository} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected RepositoryItemProvider repositoryItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Repository}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createRepositoryAdapter() {
		if (repositoryItemProvider == null) {
			repositoryItemProvider = new RepositoryItemProvider(this);
		}

		return repositoryItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.ActionSet} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ActionSetItemProvider actionSetItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.ActionSet}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createActionSetAdapter() {
		if (actionSetItemProvider == null) {
			actionSetItemProvider = new ActionSetItemProvider(this);
		}

		return actionSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Generate} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected GenerateItemProvider generateItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Generate}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createGenerateAdapter() {
		if (generateItemProvider == null) {
			generateItemProvider = new GenerateItemProvider(this);
		}

		return generateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.ConvertXmi} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ConvertXmiItemProvider convertXmiItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.ConvertXmi}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createConvertXmiAdapter() {
		if (convertXmiItemProvider == null) {
			convertXmiItemProvider = new ConvertXmiItemProvider(this);
		}

		return convertXmiItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Backup} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected BackupItemProvider backupItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Backup}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createBackupAdapter() {
		if (backupItemProvider == null) {
			backupItemProvider = new BackupItemProvider(this);
		}

		return backupItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Clear} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ClearItemProvider clearItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Clear}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createClearAdapter() {
		if (clearItemProvider == null) {
			clearItemProvider = new ClearItemProvider(this);
		}

		return clearItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Remove} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected RemoveItemProvider removeItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Remove}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createRemoveAdapter() {
		if (removeItemProvider == null) {
			removeItemProvider = new RemoveItemProvider(this);
		}

		return removeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.ChainCall} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ChainCallItemProvider chainCallItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.ChainCall}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createChainCallAdapter() {
		if (chainCallItemProvider == null) {
			chainCallItemProvider = new ChainCallItemProvider(this);
		}

		return chainCallItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.CustomAction} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CustomActionItemProvider customActionItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.CustomAction}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createCustomActionAdapter() {
		if (customActionItemProvider == null) {
			customActionItemProvider = new CustomActionItemProvider(this);
		}

		return customActionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Model} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ModelItemProvider modelItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Model}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createModelAdapter() {
		if (modelItemProvider == null) {
			modelItemProvider = new ModelItemProvider(this);
		}

		return modelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.ModelSet} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ModelSetItemProvider modelSetItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.ModelSet}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createModelSetAdapter() {
		if (modelSetItemProvider == null) {
			modelSetItemProvider = new ModelSetItemProvider(this);
		}

		return modelSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Folder} instances. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected FolderItemProvider folderItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Folder}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createFolderAdapter() {
		if (folderItemProvider == null) {
			folderItemProvider = new FolderItemProvider(this);
		}

		return folderItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Log} instances. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	protected LogItemProvider logItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Log}. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createLogAdapter() {
		if (logItemProvider == null) {
			logItemProvider = new LogItemProvider(this);
		}

		return logItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.EmfMetamodel} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EmfMetamodelItemProvider emfMetamodelItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.EmfMetamodel}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createEmfMetamodelAdapter() {
		if (emfMetamodelItemProvider == null) {
			emfMetamodelItemProvider = new EmfMetamodelItemProvider(this);
		}

		return emfMetamodelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.Generator} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected GeneratorItemProvider generatorItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.Generator}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createGeneratorAdapter() {
		if (generatorItemProvider == null) {
			generatorItemProvider = new GeneratorItemProvider(this);
		}

		return generatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all
	 * {@link fr.obeo.acceleo.chain.CustomFile} instances. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CustomFileItemProvider customFileItemProvider;

	/**
	 * This creates an adapter for a {@link fr.obeo.acceleo.chain.CustomFile}.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter createCustomFileAdapter() {
		if (customFileItemProvider == null) {
			customFileItemProvider = new CustomFileItemProvider(this);
		}

		return customFileItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the
	 * adapter. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class) type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to
	 * {@link #parentAdapterFactory}. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void dispose() {
		if (chainItemProvider != null)
			chainItemProvider.dispose();
		if (repositoryItemProvider != null)
			repositoryItemProvider.dispose();
		if (actionSetItemProvider != null)
			actionSetItemProvider.dispose();
		if (generateItemProvider != null)
			generateItemProvider.dispose();
		if (convertXmiItemProvider != null)
			convertXmiItemProvider.dispose();
		if (backupItemProvider != null)
			backupItemProvider.dispose();
		if (clearItemProvider != null)
			clearItemProvider.dispose();
		if (removeItemProvider != null)
			removeItemProvider.dispose();
		if (chainCallItemProvider != null)
			chainCallItemProvider.dispose();
		if (customActionItemProvider != null)
			customActionItemProvider.dispose();
		if (modelItemProvider != null)
			modelItemProvider.dispose();
		if (modelSetItemProvider != null)
			modelSetItemProvider.dispose();
		if (folderItemProvider != null)
			folderItemProvider.dispose();
		if (logItemProvider != null)
			logItemProvider.dispose();
		if (emfMetamodelItemProvider != null)
			emfMetamodelItemProvider.dispose();
		if (generatorItemProvider != null)
			generatorItemProvider.dispose();
		if (customFileItemProvider != null)
			customFileItemProvider.dispose();
	}

}
